// Copyright 2024 libsese
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/// @file Util.h
/// @brief 文本工具
/// @author kaoru
/// @date 2024年06月26日

#pragma once

#include <sese/Config.h>

namespace sese::text {

/// 跨平台兼容性的 snprintf
/// \param buf 输出缓存
/// \param buf_size 缓存大小
/// \param pattern 模式
/// \param ... 匹配模式参数
/// \return 结果
int snprintf(char *buf, size_t buf_size, const char *pattern, ...);

}